#include "config.h"
#include "macros.h"
#include "network.h"
#include "wrappers.h"

/*
	recv's & parses a redirect packet
*/
int ag_fetch_redirect(int s, struct sockaddr_in *addr)
{
	static unsigned char buf[256];
	int len;

	context;

	memset(buf, 0, sizeof(buf));

	/* assume that we have received the whole packet */
	len = recv(s, buf, sizeof(buf)-1, 0);
	if(len == -1)
	{
		NOTICE("Error reading data from redirect server: %s", ERRMSG());
		return 0;
	}

	/* parse packet */

	if(len < 23)
	{
		NOTICE("Redirect packet too small (%d bytes)", len);
		return 0;
	}

	if(!AG_VALID_HDR(buf) || !AG_VALID_REDIR(buf))
	{
		NOTICE("Invalid redirect packet");
		return 0;
	}

	if(AG_INT(buf+4) != len - 4)
	{
		NOTICE("Redirect packet length is invalid");
		return 0;
	}

	memset(addr, 0, sizeof(struct sockaddr_in));
	addr->sin_family = AF_INET;
	addr->sin_port = htons(AG_INT(buf+12));

	/* buf+18 is null-terminated. */
#ifdef HAVE_INET_ATON
	return inet_aton(buf+18, &addr->sin_addr);
#else
	addr->sin_addr.s_addr = inet_addr(buf+18);
	return (addr->sin_addr.s_addr == -1 /*INADDR_NONE*/) ? 0 : 1;
#endif
}
